namespace CSLint
{
    using System;
    using System.Reflection;
    using Reflector.CodeModel;

    public class ClassDesc
    {
        internal MethodDesc  methods;
		
        internal ITypeDeclaration cls;

        internal ClassDesc(ITypeDeclaration type)
        {
            cls = type;
        }
        
        public override string ToString()
        {
            return GetTypeName(cls);
        }

        public static string GetTypeName(ITypeReference type)
        {
            if (type == null)
            {
                return null;
            }
            ITypeReference owner = type.Owner as ITypeReference;
            if (owner != null)
            {
                return GetTypeName(owner) + "." + type.Name;
            }
            else
            {
                string ns = type.Namespace;
                return ns != null && ns.Length != 0 ? ns + "." + type.Name : type.Name;
            }
        }
                    


        internal MethodDesc addMethod(IMethodDeclaration mth)
        {
            return methods = new MethodDesc(methods, this, mth);
        }		

        internal MethodDesc getMethod(IMethodDeclaration mth)
        {
            for (MethodDesc md = methods; md != null; md = md.next)
            {
                if (md.method == mth)
                {
                    return md;
                }
            }
            return addMethod(mth);
        }		
		
        internal void addOverriddenMethodInvocations()
        {
            if (cls != typeof(Object)) 
            {
                for (MethodDesc mth = methods; mth != null; mth = mth.next)
                {
                    mth.addOverriddenMethodInvocations();
                }
            }
        }		

        internal String getSourceFilePath() 
        {
            // TODO: I don't know how extract symbolic infromation from CLI
            return null;
        }
    }
}