namespace CSLint
{
    using System;
    using Reflector.CodeModel;
	
    public class InvocationDesc
    {
		
        internal MethodDesc     caller;
        internal MethodDesc     method;
        internal InvocationDesc next;
        internal IExpression    expr;
        internal bool           isVirtual;
        internal GraphVertex[]  monitors;
		
        internal InvocationDesc(InvocationDesc next, 
                                MethodDesc     caller, 
                                MethodDesc     method, 
                                IExpression    expr, 
                                bool           isVirtual,
                                VertexList     monitors)
        {
            this.next = next;
            this.caller = caller;
            this.method = method;
            this.isVirtual = isVirtual;
            this.expr = expr;
            this.monitors = monitors.toArray();
        }
		
        internal InvocationDesc(InvocationDesc next, 
                                MethodDesc     method, 
                                InvocationDesc inv)
        {
            this.next = next;
            this.caller = inv.caller;
            this.method = method;
            this.expr = inv.expr;
            this.monitors = inv.monitors;
        }
		
        internal InvocationDesc(MethodDesc method)
        {
            this.method = method;
        }		
    }
}