namespace CSLint
{
    using System;
	
    public class VertexList
    {
        private GraphVertex[] arr;
        private int used;
        private GraphVertex[] cachedValue;
		
        public VertexList()
        {
            arr = new GraphVertex[8];
            used = 0;
        }
		
        public int size()
        {
            return used;
        }
		
        public bool empty()
        {
            return used == 0;
        }
		
        public void  clear()
        {
            cachedValue = null;
            used = 0;
        }
		
        public void  push(GraphVertex v)
        {
            cachedValue = null;
            if (used == arr.Length)
            {
                GraphVertex[] newArr = new GraphVertex[used * 2];
                Array.Copy(arr, 0, newArr, 0, used);
                arr = newArr;
            }
            arr[used++] = v;
        }
		
        public GraphVertex pop()
        {
            cachedValue = null;
            return arr[--used];
        }
		
        public GraphVertex top()
        {
            return arr[used - 1];
        }
		
        public virtual GraphVertex[] toArray()
        {
            if (cachedValue != null)
            {
                return cachedValue;
            }
            GraphVertex[] a = new GraphVertex[used];
            Array.Copy(arr, 0, a, 0, used);
            cachedValue = a;
            return a;
        }
    }
}